package com.eneraptor.hci

import groovy.sql.*
import java.sql.*

class SysLogController {

	def dataSource
	
    def index = { }
	
	def main = {
		
		def db_sql = new Sql(dataSource)
		
		def single = db_sql.firstRow("show data_directory")
		def loca = single.data_directory
		def partition = new File(loca)
		def totalSpace = partition.getTotalSpace()
		def freeSpace  = partition.getFreeSpace()
		
		totalSpace = (int)((totalSpace/1024)/1024)
		freeSpace = (int)((freeSpace/1024)/1024)
		
		def percent = 100 - ((int) ((freeSpace/totalSpace)*100))
		
		[totalSpace: totalSpace, freeSpace: freeSpace, percent: percent]
		
	}
	
	def browse = {
		
		flash['warnings'] = null
		
		def entries = LoggedData.list()
		Map devices = new HashMap()
		Map icons   = new HashMap()
		List unknownDevices = new ArrayList()
		DeviceInfo.list().each {
			devices[it.deviceId] = it.friendlyName
			if(it.iconPath) {
				icons[it.deviceId] = it.iconPath
			}
		}
		entries.each {
			if(!devices[it.deviceId]) {
				if(!unknownDevices.contains(it.deviceId)) {
					unknownDevices << it.deviceId
				}
			}
		}
		unknownDevices.each {
			if(!flash['warnings']) flash['warnings'] = ""
			flash['warnings'] += "<p>There was found at least one log entry for a device with id <b>${it}</b>, which is <b>unknown</b> to HCI. You should <b>add this device</b> by <b>" + g.link(controller: 'config', action: 'addDevice', params: ['deviceId' : it], "clicking here") + "</b>.</p>"
		}
		
		[data: entries, devices: devices, icons: icons]
		
	}
	
	def detail = {
		
		def detailsOf = LoggedData.findById(params.id)
		if(!detailsOf) {
			flash['errors'] = "<p>There is no logged data with id ${params.id}</p>"
			redirect(action: 'browse')
			return false
		}
		return detailsOf.getProperties()
	}
	
	def deleteEntry = {
		
		def entry = LoggedData.findById(params.id)
		if(entry) {
			entry.delete()
			flash['confirms'] = "<p>Log entry with id " + params.id + " deleted successfully.</p>"
			redirect(action: 'browse')
		} else {
			flash['errors'] = "<p>Cannot find log entry with id " + params.id + "</p>"
			redirect(action: 'browse')
		}
		
	}
	
	def graph = {
		
		List devices = new ArrayList()
		List data = new ArrayList()
		
		DeviceInfo.findAllByInputDevice(true).each {
			devices << it
		}
		
		if(params['dataList'])
			data = params['dataList']
		else if(params['deviceId'] && params['fromDate'] && params['tillDate']) {
			
			def c = LoggedData.createCriteria()
			def results = c {
				and {
					eq("deviceId",params['deviceId'])
					between("dateRecieved",params['fromDate'],params['tillDate'])
				}
				order("dateRecieved","asc")
			}
			
			results.each {
				data << [it.dateRecieved.getTime(),it.reportedData]
			}
			
		}
		
		[data: data, devices: devices, params:params]
		
	}
	
}
